VERSION 5.00
Begin VB.Form frmRefreshSystray 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "RefreshSystray"
   ClientHeight    =   990
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2250
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   990
   ScaleWidth      =   2250
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdAddIcon 
      Caption         =   "Symbol hinzufgen"
      Height          =   375
      Left            =   60
      TabIndex        =   1
      Top             =   60
      Width           =   2115
   End
   Begin VB.CommandButton cmdRefreshSystray 
      Caption         =   "RefreshSystray"
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   540
      Width           =   2115
   End
End
Attribute VB_Name = "frmRefreshSystray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'=== Fenster mit den Icons suchen ===
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

'=== Fenstergre ermitteln ===
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

'=== Mausereignisse senden ===
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const WM_MOUSEMOVE = &H200

'Als Raster kann eigentlich 16 verwendet werden. (Standardgre eines kleinen Icons)
'Man kann allerdings die Standardgre verndern, wodurch ein kleineres Raster notwendig werden knnte.
Private Const IconWidth As Long = 4
Private Const IconHeight As Long = 4


'\/---------------- Nur fr unbrauchbare Icons zum testen ----------------\/
Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long
Private Type NOTIFYICONDATA
   cbSize As Long
   hwnd As Long
   uID As Long
   uFlags As Long
   uCallbackMessage As Long
   hIcon As Long
   szTip As String * 64
End Type
Private Const NIM_ADD = &H0
Private Const NIF_ICON = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_TIP = &H4
'/\---------------- Nur fr unbrauchbare Icons zum testen ----------------/\

Private Sub cmdRefreshSystray_Click()
   RefreshSystray
End Sub

'Sub zum entfernen unbenutzter Symbole aus dem Systray
Sub RefreshSystray()
   Dim hShell_TrayWnd As Long 'Handle der Taskleiste
   Dim hTrayNotifyWnd As Long 'Handle des Bereiches mit Uhr und Symbolen
   Dim hToolbarWnd As Long    'Handle des Bereiches mit Symbolen
   
   'Finden der Handles
   hShell_TrayWnd = FindWindowEx(0, 0, "Shell_TrayWnd", vbNullString)
   hTrayNotifyWnd = FindWindowEx(hShell_TrayWnd, 0, "TrayNotifyWnd", vbNullString)
   hToolbarWnd = FindWindowEx(hTrayNotifyWnd, 0, "ToolbarWindow32", vbNullString)
   'Das Fenster mit den Icons befindet sich auf einem "Unterfenster" der Taskleiste
   
   'Sollten dort mehere Fenster mit dem Klassennamen sein, werden "vorsichtshalber" alle durchgegangen.
   Do Until hToolbarWnd = 0
      SendMouseEvents hToolbarWnd 'Simulieren der Mausbewegungen
      
      'Evtl. zum nchste Fenster mit gleicher Klassenbezeichnung wechseln
      hToolbarWnd = FindWindowEx(hTrayNotifyWnd, hToolbarWnd, "ToolbarWindow32", vbNullString)
   Loop
End Sub

'Sub zum Senden von Mausereignissen auf einem Fenster
Sub SendMouseEvents(hDestWnd As Long)
   Dim RPos As RECT
   Dim Width As Long, Height As Long
   GetWindowRect hDestWnd, RPos
   With RPos
      Width = .Right - .Left
      Height = .Bottom - .Top
   End With
Restart:
   'In einem regelmigem Raster (festgelget durch IconWidth und IconHeight)
   'werden Mausbewegungen simuliert die strende Icons verschwinden lassen.
   Dim X As Integer, Y As Integer
   For X = IconWidth / 2 To Width Step IconWidth
      For Y = IconHeight / 2 To Height Step IconHeight
         PostMouseEvent hDestWnd, X, Y
         GetWindowRect hDestWnd, RPos
         
         'Sollte sich die gre des Fensters ndern, wurde ein Icon entfernt und die anderen
         'knnten sich verschoben haben; deshalb fngt das Prog von vorne an.
         With RPos
            If Width <> .Right - .Left Or Height <> .Bottom - .Top Then 'Grenvergleich
               Width = .Right - .Left     'aktualisieren der gespeicherten Gre,
               Height = .Bottom - .Top    'fr den nchsten vergleich
               GoTo Restart               'von vorn beginnen
            End If
         End With
         
      Next
   Next
End Sub

'Sub zum Senden eines Mausereignisses an einer bestimmten Position
Sub PostMouseEvent(hDestWnd As Long, X As Integer, Y As Integer)
   'Eine Mausbewegung wird simuliert
   'lParam bestimmt die Mausposition (ersten 16 bit fr Y und letzten 16 bit fr X)
   PostMessage hDestWnd, WM_MOUSEMOVE, 0, Y * 2 ^ 16 Or X
End Sub

'\/---------------- Nur fr unbrauchbare Icons zum testen ----------------\/
'Ein unbrauchbares Icon erstellen
Private Sub cmdAddIcon_Click()
   Static i As Long
   i = i + 1
   Dim NID As NOTIFYICONDATA
   With NID
      .cbSize = Len(NID)         'Gre des Datentyps
      .hIcon = Me.Icon.Handle    'Handle eines Icons das angezeigt werden soll
      .hwnd = 0                  'Fenster an welches die Ereignisse gesendet werden
         '-> existiert das hier angegebene Fenster nicht (mehr) ist das Icon unbrauchbar
      .szTip = "Nur zum testen"  'Tooltiptext
      .uCallbackMessage = 1      'Nachricht, die das Fenster bei einem Ereignis erhlt
      .uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP 'Welche Einstellungen werden am Icon gendert (-> nur wenn ein bestehendes Icon gendert wird)
      .uID = i                   'Identifizierung des Icons (-> ntig, wenn mit mehreren Icons gearbeitet wird)
   End With
   Shell_NotifyIcon NIM_ADD, NID 'Hinzufgen eines Icons zum Systray
End Sub
'/\---------------- Nur fr unbrauchbare Icons zum testen ----------------/\
